﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_pascal_triangle_row
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // See https://en.wikipedia.org/wiki/Pascal's_triangle#Calculating_a_row_or_diagonal_by_itself
        private void btnCalculate_Click(object sender, EventArgs e)
        {
            // Get the values for the selected row.
            long row_number = long.Parse(txtRowNumber.Text);
            List<long> values = PascalRow(row_number);

            // Display the results.
            string txt = "";
            foreach (long value in values)
                txt += value.ToString() + ", ";
            txtResults.Text = txt.Substring(0, txt.Length - 2);
        }

        // Return the coefficients in a row of Pascal's triangle.
        private List<long> PascalRow(long row_number)
        {
            checked
            {
                long n = row_number;

                // Make the results as a list of long.
                List<long> results = new List<long>();
                long value = 1;
                results.Add(value);

                // Calculate the values.
                for (int k = 1; k <= n; k++)
                {
                    value = (value * (n + 1 - k)) / k;
                    results.Add(value);
                }

                return results;
            }
        }
    }
}
